﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using System.IO;
using System.Windows.Media;
using System.ComponentModel;
using System.Runtime.CompilerServices;

using Infragistics.Controls.Charts;


namespace WPF3DSurfaceTest
{
    public class ViewModel : INotifyPropertyChanged
    {

        List<DataPoint> m_eyeData;
        ColorCollection m_eyeColors;


        public event PropertyChangedEventHandler PropertyChanged;

        protected void NotifyPropertyChanged([CallerMemberName] String propertyName = "")
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }

        public ViewModel() 
        {
            EyeData = GenerateEyeData();
            EyeColors = GenerateEyeColors();
        }

        protected List<DataPoint> GenerateEyeData()
        {
            var data = new List<DataPoint>();
            var reader = new StreamReader(File.OpenRead(@"C:\Users\vonzwi.HEARING\Documents\Test\WPF3DSurfaceTest\WPF3DSurfaceTest\WPF3DSurfaceTest\Data\Eye.txt"));

            while (!reader.EndOfStream)
            {
                var line = reader.ReadLine();
                var values = line.Split(',');

                if (values.Count() == 3)
                {
                    DataPoint point = new DataPoint(Convert.ToDouble(values[0]), Convert.ToDouble(values[1]), Convert.ToDouble(values[2]));
                    data.Add(point);
                }
            }
            return data;
        }

        protected ColorCollection GenerateEyeColors()
        {
            var eyeColors = new ColorCollection();
            eyeColors.Add(Colors.DarkGreen);
            eyeColors.Add(Colors.Lime);
            eyeColors.Add(Colors.LightGreen);

            return eyeColors;
        }
        public List<DataPoint> EyeData
        {
            get { return m_eyeData; }
            set
            {
                m_eyeData = value;
                NotifyPropertyChanged();
            }
        }

        public ColorCollection EyeColors
        {
            get { return m_eyeColors; }
            set
            {
                m_eyeColors = value;
                NotifyPropertyChanged();
            }
        }
    }
}
